
public class QueueDriver {

	public static void main(String[] args) {
		ArrayBasedQueue<Integer> abq = new ArrayBasedQueue<Integer>(20);

		System.out.println("\n\nAdd 20 elements to the queue");

		for ( int i = 0 ; i < 20 ; i++ ) {
			abq.enqueue(i);
		}
		
		System.out.println(abq);

		System.out.println("\n\nAdd 21st element to the queue");
		
		try {
			abq.enqueue(20);
		} catch (Exception e) {
			System.out.println("Exception occured");
			e.printStackTrace();
		}

		System.out.println("\n\nDequeue the first 5 elements from the queue");
		
		for ( int i = 0 ; i < 5 ; i++ ) {
			Integer integer = abq.dequeue();
		}
		
		System.out.println(abq);

		System.out.println("\n\nEnqueue 3 new elements in the queue");
		
		for ( int i = 21 ; i < 24 ; i++ ) {
			abq.enqueue(i);
		}
		
		System.out.println(abq);

		System.out.println("\n\nTry to add a \"null\" element to the queue");

		try {
			abq.enqueue(null);
		} catch (Exception e) {
			System.out.println("Exception occured");
			e.printStackTrace();
		}

		System.out.println("\n\nDequeue from index 0");
		
		int e = abq.dequeue(0);
		System.out.println("Element = " + e);
		System.out.println(abq);

		System.out.println("\n\nDequeue from index 16");
		
		e = abq.dequeue(16);
		System.out.println("Element = " + e);
		System.out.println(abq);

		System.out.println("\n\nDequeue from index 7");
		
		e = abq.dequeue(7);
		System.out.println("Element = " + e);
		System.out.println(abq);

		System.out.println("\n\nRemove all elements from the queue");
		
		abq.removeAll();
		System.out.println(abq);
		
	}

}
